#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>

#include "File_Selector.h"
#include <dirent.h>

#ifndef WIN32
#include <sys/ipc.h>
#include <sys/msg.h>
#endif

#include "version.h"
#include "flarq.h"
#include "arq.h"
#include "arqdialogs.h"
#include "b64.h"

Fl_Text_Buffer *txtbuff;

#ifndef WIN32
struct RXMSGSTRUC {
	long int msg_type;
	char c;
};

struct TXMSGSTRUC {
	long int msg_type;
	char buffer[BUFSIZ];
};

RXMSGSTRUC rxmsgst;
int rxmsgid;

TXMSGSTRUC txmsgst;
int txmsgid;
#endif

Fl_Double_Window *arqwin = 0;
Fl_Double_Window *dlgconfig = 0;
Fl_Double_Window *outdialog = 0;

using namespace std;

arq *digi_arq;
bool traffic = false;
bool sendingfile = false;
int  arqstate = 0;
bool configured = false;

string RX;
string TX;

string teststring;

string statusmsg;

string MyCall = "";
string beacontext;

#ifdef WIN32
char   szHomedir[120] = "c:/NBEMS";
string str_homedir = "c:/NBEMS";
string str_xfrdir = "c:/NBEMS/ARQXFR";
string str_txfile = "c:/NBEMS/ARQXFR/txfile";
string str_rxfile = "c:/NBEMS/ARQXFR/rxfile";
string MailFolder = "Mail";
string MailInFolder = "Mail/ARQin";
string MailOutFolder = "Mail/ARQout";
string MailSentFolder = "Mail/ARQsent";
string InFolder  = "ARQrecv";
string OutFolder = "ARQsend";
string MailFileName = "";
string MailSaveFileName = "";
bool   SendingEmail = false;
struct dirent *entry;
DIR *dp;
#else
char	szHomedir[120];
string str_txfile = "arqfiles/txfile.arq";
string str_rxfile = "arqfiles/rxfile.arq";
string MailFolder = "Mail";
string MailInFolder = "Mail/ARQin";
string MailOutFolder = "Mail/ARQout";
string MailSentFolder = "Mail/ARQsent";
string InFolder  = "ARQrecv";
string OutFolder = "ARQsend";
string MailFileName = "";
string MailSaveFileName = "";
bool   SendingEmail = false;
struct dirent *entry;
DIR *dp;
#endif


int    exponent = 5;
int	   txdelay = 500;
int    retries = 5;
int    waittime = 5000;
int    timeout = 60000;
int	   bcnInterval = 60;
bool   autobeacon = false;

int mainX = 0, mainY = 0, mainW = 765, mainH = 265;

float  vers = 0;
float  version = VERSION;

char *ASCII[32] = {
	"<NUL>", "<SOH>", "<STX>", "<ETX>", // 0x00 - 0x03
	"<EOT>", "<ENQ>", "<ACK>", "<BEL>", // 0x04 - 0x07
	"<BX>",  "<TAB>", "<LF>",  "<VT>",  // 0x08 - 0x0B
	"<FF>",  "<CR>",  "<SO>",  "<SI>",  // 0x0C - 0x0F
	"<DLE>", "<DC1>", "<DC2>", "<DC3>", // 0x10 - 0x13
	"<DC4>", "<NAK>", "<SYN>", "<ETB>", // 0x14 - 0x17
	"<CAN>", "<EM>",  "<SUB>", "<ESC>", // 0x18 - 0x1B
	"<FS>",  "<GS>",  "<RS>",  "<US>",  // 0x1C - 0x1F
};

void debug(string s)
{
	string strdebug;
	strdebug = "";

	for (unsigned int i = 0; i < s.length(); i++)
		if (s[i] < 32)
			strdebug += ASCII[(int)s[i]];
		else
			strdebug += s[i];
	std::cout << strdebug << std::endl; std::cout.flush();
	ofstream rxtext("debug.txt", ios::app);
	rxtext << strdebug;
	rxtext.close();
}

void initVals()
{
	MyCall = "URCALL";
	exponent = digi_arq->getExponent();
	retries = digi_arq->getRetries();
	timeout = digi_arq->getTimeout();
	txdelay = digi_arq->getTxDelay();
	waittime = digi_arq->getWaitTime();
	beacontext = "";
	cbMenuConfig();		
	digi_arq->myCall(MyCall.c_str());
}

void testDirectory(string dir)
{
	string tstdir = szHomedir;
	tstdir += '/';
	tstdir.append(dir);
	ifstream test(tstdir.c_str());
	if (!test)
#ifdef WIN32
		mkdir(tstdir.c_str());
#else
		mkdir(tstdir.c_str(), O_CREAT | S_IRUSR|S_IWUSR|S_IXUSR);
#endif
	else
		test.close();
}

void readConfig()
{
	extern void cbMenuConfig();
	string configfname = szHomedir;
#ifndef WIN32
	configfname.append("/.flarq");
#else
	configfname.append("/flarq.config");
#endif
	ifstream configfile(configfname.c_str());
	if (configfile) {
		char tempstr[200];
		configfile >> vers;
		if (vers != version) 
			initVals();
		else {
			configfile >> MyCall;
			configfile >> InFolder;
			configfile >> OutFolder;
			configfile >> MailInFolder;
			configfile >> MailOutFolder;
			configfile >> MailSentFolder;
			configfile >> exponent;
			configfile >> txdelay;
			configfile >> retries;
			configfile >> waittime;
			configfile >> timeout;
			configfile >> bcnInterval;
			configfile >> mainX;
			configfile >> mainY;
			configfile >> mainW;
			configfile >> mainH;
			configfile.ignore();
			configfile.getline(tempstr, 199);
			beacontext = tempstr;
			digi_arq->myCall(MyCall.c_str());
			digi_arq->setExponent(exponent);
			digi_arq->setRetries(retries);
			digi_arq->setTimeout(timeout);
			digi_arq->setTxDelay(txdelay);
			digi_arq->setWaitTime(waittime);
		}
		configfile.close();
	} else
		initVals();

	testDirectory(InFolder);
	testDirectory(OutFolder);
	testDirectory(MailFolder);
	testDirectory(MailInFolder);
	testDirectory(MailOutFolder);
	testDirectory(MailSentFolder);

	arqwin->label(MyCall.c_str());
//	arqwin->resize(mainX, mainY, mainW, mainH);
}

void saveConfig()
{
	string configfname = szHomedir;
#ifndef WIN32
	configfname.append("/.flarq");
#else
	configfname.append("/flarq.config");
#endif
	ofstream configfile(configfname.c_str());
	if (configfile) {
		int mainX = arqwin->x();
		int mainY = arqwin->y();
		int mainW = arqwin->w();
		int mainH = arqwin->h();
		configfile << VERSION << endl;
		configfile << MyCall << endl;
		configfile << InFolder << endl;
		configfile << OutFolder << endl;
		configfile << MailInFolder << endl;
		configfile << MailOutFolder << endl;
		configfile << MailSentFolder << endl;
		configfile << exponent << endl;
		configfile << txdelay << endl;
		configfile << retries << endl;
		configfile << waittime << endl;
		configfile << timeout << endl;
		configfile << bcnInterval << endl;
		configfile << mainX << endl;
		configfile << mainY << endl;
		configfile << mainW << endl;
		configfile << mainH << endl;
		configfile << beacontext.c_str() << endl;
		configfile.close();
	}
}

void closeConfig()
{
	if (dlgconfig)
		dlgconfig->hide();
	digi_arq->setExponent(exponent);
	digi_arq->setRetries(retries);
	digi_arq->setTimeout(timeout);
	digi_arq->setTxDelay(txdelay);
	digi_arq->setWaitTime(waittime);
}

void cbMenuConfig() 
{
	if (!dlgconfig) dlgconfig = arq_configure();
	dlgconfig->show();
}

void cbMenuAbout()
{
	fl_message("\
flarq - ARQ client\n\
version: %4.2f\n\
w1hkj@w1hkj.com", VERSION);
}

void client_transmit( string s )
{
//	debug(s);
#ifdef WIN32
	ofstream txfile(str_txfile.c_str(), ios::binary);
	if (!txfile) {
		cerr << "Cannot open txfile.arq\n";
		exit(1);
	}
	txfile.write(s.c_str(), s.length());
	txfile.close();
#else
	txmsgst.msg_type = 1;
	memset(txmsgst.buffer, 0, BUFSIZ); 
	strncpy(txmsgst.buffer, s.c_str(), BUFSIZ-1);
	msgsnd(txmsgid, (void *)&txmsgst, BUFSIZ, IPC_NOWAIT);
#endif
}

void openMsgQueue()
{
#ifndef WIN32
	rxmsgid = msgget( (key_t) 9876, 0666 | IPC_CREAT);
	txmsgid = msgget( (key_t) 6789, 0666 | IPC_CREAT);
#endif
}

#define RXBUFSIZE 2048
char rxbuffer[RXBUFSIZE];
int  bufsize = 0;
int  bufptr = 0;

bool client_receive(char &c)
{
	if (bufsize) {
		c = rxbuffer[bufptr];
		bufptr++;
		if (bufptr == bufsize) {
			bufsize = 0;
			bufptr = 0;
		}
		return true;
	}
#ifdef WIN32
	FILE *rxfile;
	rxfile = fopen(str_rxfile.c_str(), "rb");
	if (rxfile) {
		bufsize = fread(rxbuffer, 1, RXBUFSIZE, rxfile);
		fclose(rxfile);
		remove (str_rxfile.c_str());
	}
#else
	bufsize = 0;
	while (msgrcv (rxmsgid, (void *)&rxmsgst, 1, 0, IPC_NOWAIT) != -1 && bufsize < RXBUFSIZE) {
		rxbuffer[bufsize++] = rxmsgst.c;
	}
#endif
	return false;
}

int autobeaconcounter = 0;
char bcnMsg[40];

void arqAutoBeacon(void *)
{
	if (autobeacon == true) {
		int currstate = digi_arq->state();
		if (currstate > 0x7F) {
			Fl::repeat_timeout(1.0, arqAutoBeacon);			
			return;
		} else if (currstate == DOWN) {
			if (autobeaconcounter == 0) {
				btnBEACON->label("Beacon");
				btnBEACON->redraw_label();
				string bcntxt = "\n<<< FLARQ Beacon >>> de ";
				bcntxt += MyCall;
				digi_arq->sendPlainText(bcntxt);
				while (digi_arq->state() > 0x7F)
					Fl::wait();
				digi_arq->sendUnproto( beacontext );
				autobeaconcounter = bcnInterval;
				Fl::repeat_timeout(1.0 + txdelay / 1000.0, arqAutoBeacon);
			} else {
				sprintf(bcnMsg, "%d sec", autobeaconcounter);
				btnBEACON->label(bcnMsg);
				btnBEACON->redraw_label();
				autobeaconcounter--;
				Fl::repeat_timeout(1.0, arqAutoBeacon);
			}
			return;
		} else {
			autobeaconcounter = 0;
			btnBEACON->value(0);
			btnBEACON->label("Beacon");
			btnBEACON->redraw_label();
		}
	} else {
		autobeaconcounter = 0;
		btnBEACON->value(0);
		btnBEACON->label("Beacon");
		btnBEACON->redraw_label();
	}
}

void arqBEACON()
{
	if (autobeacon == false) {
		autobeacon = true;
		Fl::add_timeout(0.01, arqAutoBeacon);
	} else {
		autobeacon = false;
	}
}

void arqCLOSE()
{
#ifndef WIN32
	msgctl (rxmsgid, IPC_RMID, 0);
	msgctl (txmsgid, IPC_RMID, 0);
#endif
	saveConfig();
	exit(0);
}
	
void arqCONNECT()
{
	if (digi_arq->connected() == false) {
		if (strlen(txtURCALL->value()) > 0)
			digi_arq->connect(txtURCALL->value());
	} else {
		digi_arq->disconnect();
		txtURCALL->value("");
	}
}

string incomingText = "";
string txtarqload = "";
string rxfname = "";
string arqstart = "ARQ::STX\n";
string arqend   = "ARQ::ETX\n";
string arqfile = "ARQ:FILE::";
string arqemail = "ARQ:EMAIL::\n";
string arqascii = "ARQ:ENCODING::ASCII\n";
string arqbase64 = "ARQ:ENCODING::BASE64\n";
string arqsizespec = "ARQ:SIZE::";
size_t startpos = string::npos;
size_t endpos = string::npos;
size_t fnamepos = string::npos;
size_t indx = string::npos;
size_t sizepos = string::npos;
size_t lfpos = string::npos;
size_t arqPayloadSize = 0;
bool haveemail = false;
bool rxARQfile = false;
bool rxARQhavesize = false;
bool rxTextReady = false;

bool fileExists(string fname)
{
	ifstream test(fname.c_str());
	if (test) {
		test.close();
		return true;
	}
	return false;
}

string nextFileName(string fname)
{
	int fnbr;
	string newname = "";
	string name;
	size_t pos = fname.find_last_of('/');
	if (pos == string::npos) pos = 0;
	if (pos)
		newname = fname.substr(0, pos+1);
	name = fname.substr(pos+1);
	if (sscanf(name.c_str(), "%d", &fnbr) == 1)
		fnbr++;
	else
		fnbr = 1;
	char szNbr[8];
	sprintf(szNbr, "%d", fnbr);
	newname.append(szNbr);
	return newname;
}

void saveEmailFile()
{
	string savetoname = szHomedir;
	savetoname += '/';
	savetoname.append(MailInFolder);
	savetoname += '/';
	savetoname.append(rxfname);

	while (fileExists(savetoname))
		savetoname = nextFileName(savetoname);
		
	ofstream tfile(savetoname.c_str());
	if (tfile) {
		tfile << txtarqload;
		tfile.close();
	}
	
	rxfname = "";
	txtarqload = "";
	rxTextReady = false;
}

void saveRxFile()
{
	string savetoname = szHomedir;
	savetoname += '/';
	savetoname.append(InFolder);
	savetoname += '/';
	savetoname.append(rxfname);
	if (fileExists(savetoname)) {
		int ans = fl_choice("File exists, overwrite?", "No", "Yes", NULL);
		if (ans == 0) {
			char *p =  File_Select("Save to:", "*", savetoname.c_str(), 0);
			if (p) {
				ofstream tfile(p, ios::binary);
				if (tfile) {
					tfile << txtarqload;
					tfile.close();
				}
			}
		} else {
			ofstream tfile(savetoname.c_str(), ios::binary);
			if (tfile) {
				tfile << txtarqload;
				tfile.close();
			}
		}
	} else {
		ofstream tfile(savetoname.c_str(), ios::binary);
		if (tfile) {
			tfile << txtarqload;
			tfile.close();
		}
	}
	
	rxfname = "";
	txtarqload = "";
	rxTextReady = false;
}

void payloadText(string s)
{
	txtIncoming->insert(s.c_str());
	txtIncoming->show_insert_position();

	incomingText.append (s);
	if (!rxARQfile)
		if ((startpos = incomingText.find(arqstart)) != string::npos) {
			rxARQfile = true;
			startpos += arqstart.length();
		}
	if (rxARQfile) {
		if (!rxARQhavesize) {
			if ( (sizepos = incomingText.find(arqsizespec)) != string::npos) {
				sizepos += arqsizespec.length();
				if ((lfpos = incomingText.find('\n', sizepos)) != string::npos) {
					string sizechars = incomingText.substr(sizepos, lfpos - sizepos);
					sscanf(sizechars.c_str(), "%d", &arqPayloadSize);
					rxARQhavesize = true;
					char statusmsg[40];
					sprintf(statusmsg, "Rcvg: %d", arqPayloadSize);
					txtStatus->value(statusmsg);
				}
			}
		} else {
			prgStatus->value(1.0*(incomingText.length() - startpos)/arqPayloadSize);
		}
		if ((endpos = incomingText.find(arqend)) != string::npos) {
			haveemail = false;
			fnamepos = incomingText.find(arqfile);
			fnamepos += arqfile.length();
			indx = incomingText.find('\n', fnamepos);
			rxfname = incomingText.substr(fnamepos, indx - fnamepos);
			txtarqload = incomingText.substr(startpos, endpos - startpos);
			if (incomingText.find(arqbase64) != string::npos) {
				base64 b64;
				txtarqload = b64.decode(txtarqload);
			}
			if (incomingText.find(arqemail) != string::npos)
				haveemail = true;
			incomingText = "";
			startpos = string::npos;
			endpos = string::npos;
			fnamepos = string::npos;
			indx = string::npos;
			sizepos = string::npos;
			lfpos = string::npos;
			arqPayloadSize = 0;
			rxARQfile = false;
			rxARQhavesize = false;
			rxTextReady = true;
			txtStatus->value("");
			prgStatus->value(0.0);
		}
	}
}

void cbClearText()
{
	txtbuff->text("");
}

void clearText()
{
	txtarqload = "";
	txtbuff->text("");
	txtStatus->value("");
}

void abortedTransfer()
{
	TX.clear();
	rxfname = "";
	rxTextReady = false;
	prgStatus->value(0.0);
	clearText();
	txtIncoming->insert("transfer aborted\n");
}

void abortTransfer()
{
	abortedTransfer();
	digi_arq->abort();
	sendingfile = false;
	SendingEmail = false;
}

void cbAbort()
{
	if (autobeacon == true) {
		autobeacon = false;
		return;
	}
	switch (arqstate) {
		case CONNECTING:
		case WAITFORACK:
			clearText();
			digi_arq->abort();
			break;
		case CONNECTED:
		case WAITING:
			if (!digi_arq->transferComplete())
				abortTransfer();
			else
				digi_arq->disconnect();
			break;
		default: break;
	}
}


void unprotoText(string s)
{
	txtURCALL->value(s.c_str());
}

int datedir = 1;

void cb_SortByDate()
{
	if (datedir == 0) {
		tblOutgoing->sort(1, false);
		datedir = 1;
	} else {
		tblOutgoing->sort(1, true);
		datedir = 0;
	}
	tblOutgoing->redraw();	
}

int todir = 1;

void cb_SortByTo()
{
	if (todir == 0) {
		tblOutgoing->sort(2, false);
		todir = 1;
	} else {
		tblOutgoing->sort(2, true);
		todir = 0;
	}	
	tblOutgoing->redraw();	
}

int subdir = 1;

void cb_SortBySubj()
{
	if (subdir == 0) {
		tblOutgoing->sort(3, false);
		subdir = 1;
	} else {
		tblOutgoing->sort(3, true);
		subdir = 0;
	}	
	tblOutgoing->redraw();	
}

string sendfilename = "";

void sendOK()
{
	outdialog->hide();
	int sel = tblOutgoing->value();
	if (sel >= 0)
		sendfilename = tblOutgoing->valueAt(sel,0);
	else
		sendfilename.clear();
}

void sendCancel()
{
	outdialog->hide();
	sendfilename.clear();
}

void selectTrafficOut()
{
	if (outdialog == 0) {
		outdialog = arq_SendSelect();
		tblOutgoing->addHiddenColumn ("fnbr");
		tblOutgoing->addColumn ("Date", 160);
		tblOutgoing->addColumn ("To", 84);
		tblOutgoing->addColumn ("Subj", 240);
		tblOutgoing->colcallback (1, cb_SortByDate);
		tblOutgoing->colcallback (2, cb_SortByTo);
		tblOutgoing->colcallback (3, cb_SortBySubj);
		tblOutgoing->allowSort(true);
		tblOutgoing->rowSize (20);
		tblOutgoing->headerSize (20);
		tblOutgoing->allowResize (true);
		tblOutgoing->gridEnabled (true);
	}
	tblOutgoing->clear();
	string fname, fdate, fto, fsubj;
	char fline[200];
	string folder = szHomedir;
	folder += '/';
	folder.append(MailOutFolder);
	dp = 0;
	dp = opendir(folder.c_str());
	if (dp == 0) {
		string nfound = folder;
		nfound += " not found";
		fl_message(nfound.c_str());
		return;
	}
	folder += '/';
	int nummails = 0;
	while ((entry = readdir(dp)) != 0) {
		if (entry->d_name[0] == '.')
			continue;
		fname = folder; fname.append(entry->d_name);
		int got3 = 0;
		ifstream emailtxt(fname.c_str());
		while (got3 < 3 && !emailtxt.eof()) {
			emailtxt.getline(fline,199);
			if (strstr(fline, "Date: ") == fline) {
				fdate = &(fline[12]);
				got3++;
				continue;
			}
			if (strstr(fline, "To: ") == fline) {
				fto = &(fline[4]);
				got3++;
				continue;
			}
			if (strstr(fline, "Subject: ") == fline) {
				fsubj = &(fline[9]);
				got3++;
				continue;
			}
		}
		emailtxt.close();
		if (got3 == 3) {
			tblOutgoing->addRow (4, fname.c_str(), fdate.c_str(), fto.c_str(), fsubj.c_str());
			nummails++;
		}			
	}
	if (nummails) {
		tblOutgoing->FirstRow();
		outdialog->show();
		while (outdialog->shown())
			Fl::wait();
	} else
		fl_message("No emails for delivery");
}

void moveEmailFile()
{
	if (MailFileName.empty()) return;
	if (MailSaveFileName.empty()) return;
	
	ifstream infile(MailFileName.c_str(), ios::in | ios::binary);
	
	while (fileExists(MailSaveFileName))
		MailSaveFileName = nextFileName(MailSaveFileName);

	ofstream outfile(MailSaveFileName.c_str(), ios::out | ios::binary);
	char c;

	if (infile && outfile) {
		while (!infile.eof()) {
			infile.get(c);
			outfile.put(c);
		}
		infile.close();
		outfile.close();
		unlink(MailFileName.c_str());
	}
	MailFileName.clear();
	MailSaveFileName.clear();
}


void sendEmailFile()
{
	selectTrafficOut();

	if (sendfilename.empty())
		return;	

	char cin;
	size_t txtsize;
	string textin = "";
	char sizemsg[40];
	size_t p;
	
	ifstream textfile;
	textfile.open(sendfilename.c_str(), ios::binary);
	if (textfile) {
		MailFileName = sendfilename;
		TX.erase();
		TX.append(arqfile);
		MailSaveFileName = szHomedir;
		MailSaveFileName += '/';
		MailSaveFileName.append(MailSentFolder);
		MailSaveFileName += '/';
		p = sendfilename.find_last_of('/');
		if (p != string::npos) p++;
		MailSaveFileName.append(sendfilename.substr(p));
		TX.append(sendfilename.substr(p));
		TX.append("\n");
		TX.append(arqemail);
		while (textfile.get(cin))
			textin += cin;
		textfile.close();
		txtsize = textin.length();
		sprintf(sizemsg,"ARQ:SIZE::%d\n", txtsize);
		TX.append(sizemsg);
		TX.append(arqstart);
		TX.append(textin);
		TX.append(arqend);
		traffic = true;
		statusmsg = "Sending email: ";
		statusmsg.append(sendfilename.substr(p));
		txtStatus->value(statusmsg.c_str());
		SendingEmail = true;
		sendingfile = true;
		return;
	}

	traffic = false;
	sendingfile = false;
	SendingEmail = false;
}

void sendAsciiFile()
{
	string readfromname = szHomedir;
	readfromname += '/';
	readfromname.append(OutFolder);
	readfromname += '/';
	readfromname.append(rxfname);
	const char *p = File_Select("ARQ text file", "*.txt\t*", readfromname.c_str(), 0);
	char cin;
	size_t txtsize;
	string textin = "";
	char sizemsg[40];
	if (p) {
		ifstream textfile;
		textfile.open(p);
		if (textfile) {
			TX.erase();
			TX.append(arqfile);
			p = fl_filename_name(p);
			TX.append(p);
			TX.append("\n");
			TX.append(arqascii);
			while (textfile.get(cin))
				textin += cin;
			textfile.close();
			txtsize = textin.length();
			sprintf(sizemsg,"ARQ:SIZE::%d\n", txtsize);
			TX.append(sizemsg);
			TX.append(arqstart);
			TX.append(textin);
			TX.append(arqend);
			traffic = true;
			sendingfile = true;
			statusmsg = "Sending ASCII file: ";
			statusmsg.append(p);
				txtStatus->value(statusmsg.c_str());
			return;
		}
	}
	traffic = false;
	sendingfile = false;
}

void sendImageFile()
{
	const char *p = File_Select("ARQ image file", "*.{png,jpg,bmp}\t*", "", 0);
	char cin;
	size_t txtsize, b64size;
	string textin = "";
	string b64text;
	base64 b64(true);
	char sizemsg[40];
	if (p) {
		ifstream textfile;
		textfile.open(p, ios::binary);
		if (textfile) {
			TX.erase();
			TX.append(arqfile);
			p = fl_filename_name(p);
			TX.append(p);
			TX.append("\n");
			TX.append(arqbase64);
			while (textfile.get(cin))
				textin += cin;
			textfile.close();
			txtsize = textin.length();
			b64text = b64.encode(textin);
			b64size = b64text.length();
			sprintf(sizemsg,"ARQ:SIZE::%d\n", b64size);
			TX.append(sizemsg);
			TX.append(arqstart);
			TX.append(b64text);
			TX.append(arqend);
			traffic = true;
			sendingfile = true;
			statusmsg = "Sending image: ";
			statusmsg.append(p);
				txtStatus->value(statusmsg.c_str());
			return;
		}
	}
	traffic = false;
	sendingfile = false;
}

void sendBinaryFile()
{
	const char *p = File_Select("ARQ file", "*", "", 0);
	char cin;
	size_t txtsize, b64size;
	string textin = "";
	string b64text;
	base64 b64(true);
	char sizemsg[40];
	if (p) {
		ifstream textfile;
		textfile.open(p, ios::binary);
		if (textfile) {
			TX.erase();
			TX.append(arqfile);
			p = fl_filename_name(p);
			TX.append(p);
			TX.append("\n");
			TX.append(arqbase64);
			while (textfile.get(cin))
				textin += cin;
			textfile.close();
			txtsize = textin.length();
			b64text = b64.encode(textin);
			b64size = b64text.length();
			sprintf(sizemsg,"ARQ:SIZE::%d\n", b64size);
			TX.append(sizemsg);
			TX.append(arqstart);
			TX.append(b64text);
			TX.append(arqend);
			traffic = true;
			sendingfile = true;
			statusmsg = "Sending binary: ";
			statusmsg.append(p);
				txtStatus->value(statusmsg.c_str());
			return;
		}
	}
	traffic = false;
	sendingfile = false;
}

void dispState()
{
	int currstate = digi_arq->state();

	arqstate = currstate & 0x7F;

	if (arqstate == DOWN )
		btnCONNECT->label("Connect");
	else
		btnCONNECT->label("DisConnect");
	btnCONNECT->redraw_label();

	if (arqstate > TIMEDOUT || autobeacon == true)
		btnAbort->activate();
	else
		btnAbort->deactivate();

	if (currstate > 0x7F) { // transmitting
		indCONNECT->color(FL_RED);
		indCONNECT->redraw();
	} else // receiving or idle
		switch (currstate) {
			case CONNECTING :
				indCONNECT->color(FL_YELLOW);
				indCONNECT->redraw();
				txtState->value("CONNECTING");
				txtState->redraw();
				autobeacon = false;
				break;
			case WAITFORACK :
				indCONNECT->color(FL_YELLOW);
				indCONNECT->redraw();
				txtState->value("CONNECTING");
				txtState->redraw();
				autobeacon = false;
				break;
			case WAITING :
			case CONNECTED : 
				indCONNECT->color(FL_GREEN);
				indCONNECT->redraw();
				txtState->value("CONNECTED");
				txtState->redraw();
				txtURCALL->value( digi_arq->urCall().c_str() );
				autobeacon = false;
				break;
			case TIMEDOUT :
				indCONNECT->color(FL_BLACK);
				indCONNECT->redraw();
				txtState->value("TIMED OUT");
				txtState->redraw();
				txtStatus->value("");
				txtStatus->redraw();
				txtURCALL->value("");
				txtURCALL->redraw();
				autobeacon = false;
				break;
			case DOWN :
			default :
				indCONNECT->color(FL_WHITE);
				indCONNECT->redraw();
				txtState->value("NOT CONNECTED");
				txtState->redraw();
				txtStatus->value("");
				txtStatus->redraw();
		}
	if (!rxARQfile) {
		float pcnt = digi_arq->percentSent(); // for both Send and Receive
		if (pcnt == -1.0) {
			prgStatus->value(0.0);
			if (sendingfile == true) {
				txtStatus->value("Transfer Completed");
				sendingfile = false;
			}
			if (SendingEmail == true) {
				moveEmailFile();
				SendingEmail = false;
			}
		} else {
			prgStatus->value( pcnt );
		}
	}
}

void mainloop(void *)
{

	if (traffic) {
		digi_arq->sendText(TX);
		traffic = false;
	}
	dispState();
	if (rxTextReady) {
		if (haveemail)
			saveEmailFile();
		else
			saveRxFile();
	}
	Fl::repeat_timeout(0.1, mainloop);
}

void changeMyCall(const char *nucall)
{
	int currstate = digi_arq->state();
	if (currstate != DOWN) 
		return;
		
	MyCall = nucall;
	for (size_t i = 0; i < MyCall.length(); i++)
		MyCall[i] = toupper(MyCall[i]);

	arqwin->label(MyCall.c_str());
	txtMyCall->value(MyCall.c_str());
	digi_arq->myCall(MyCall.c_str());
}

void changeBeaconText(const char *txt)
{
	beacontext = txt;
}

int main (int argc, char *argv[] )
{

#ifdef WIN32
	
// designate the arq home directory in Windows
// create if it does not exist
	strcpy(szHomedir, str_homedir.c_str());
	ifstream test(str_homedir.c_str());
	if (!test)
		mkdir(str_homedir.c_str());
	test.close();

	test.open(str_xfrdir.c_str());
	if (!test)
		mkdir(str_xfrdir.c_str());
	test.close();

#else
	fl_filename_expand(szHomedir, 119, "$HOME");
#endif	
	
	arqwin = arq_dialog();
	digi_arq = new arq();

#ifndef WIN32	
	openMsgQueue();
#endif
// the following sequence of assigning callback functions is mandatory
// for the arq class to function
	digi_arq->setSendFunc (client_transmit);
	digi_arq->setGetCFunc (client_receive);
	digi_arq->setPutText (payloadText);
	digi_arq->setAbortedTransfer(abortedTransfer);
	digi_arq->setUnprotoText (unprotoText);
	digi_arq->start_arq();

	readConfig();	

	arqwin->resize(mainX, mainY, mainW, mainH);
	
	Fl::add_timeout(0.1, mainloop);

	arqwin->show();
	return Fl::run();
}
